/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
package org.eclipse.lsat.dispatching.teditor.serializer;

import com.google.inject.Inject;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.lsat.dispatching.teditor.services.DispatchingGrammarAccess;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AlternativeAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.GroupAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public abstract class AbstractDispatchingSyntacticSequencer extends AbstractSyntacticSequencer {

	protected DispatchingGrammarAccess grammarAccess;
	protected AbstractElementAlias match_ActivityDispatching___ThroughputKeyword_2_0_LeftCurlyBracketKeyword_2_1_RightCurlyBracketKeyword_2_4__q;
	protected AbstractElementAlias match_AttributesMapEntry_ColonKeyword_2_0_or_EqualsSignKeyword_2_1;
	protected AbstractElementAlias match_DispatchGroup___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q;
	protected AbstractElementAlias match_Dispatch___LeftParenthesisKeyword_2_0_RightParenthesisKeyword_2_3__q;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (DispatchingGrammarAccess) access;
		match_ActivityDispatching___ThroughputKeyword_2_0_LeftCurlyBracketKeyword_2_1_RightCurlyBracketKeyword_2_4__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getActivityDispatchingAccess().getThroughputKeyword_2_0()), new TokenAlias(false, false, grammarAccess.getActivityDispatchingAccess().getLeftCurlyBracketKeyword_2_1()), new TokenAlias(false, false, grammarAccess.getActivityDispatchingAccess().getRightCurlyBracketKeyword_2_4()));
		match_AttributesMapEntry_ColonKeyword_2_0_or_EqualsSignKeyword_2_1 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getAttributesMapEntryAccess().getColonKeyword_2_0()), new TokenAlias(false, false, grammarAccess.getAttributesMapEntryAccess().getEqualsSignKeyword_2_1()));
		match_DispatchGroup___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getDispatchGroupAccess().getLeftParenthesisKeyword_3_0()), new TokenAlias(false, false, grammarAccess.getDispatchGroupAccess().getRightParenthesisKeyword_3_2()));
		match_Dispatch___LeftParenthesisKeyword_2_0_RightParenthesisKeyword_2_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getDispatchAccess().getLeftParenthesisKeyword_2_0()), new TokenAlias(false, false, grammarAccess.getDispatchAccess().getRightParenthesisKeyword_2_3()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_ActivityDispatching___ThroughputKeyword_2_0_LeftCurlyBracketKeyword_2_1_RightCurlyBracketKeyword_2_4__q.equals(syntax))
				emit_ActivityDispatching___ThroughputKeyword_2_0_LeftCurlyBracketKeyword_2_1_RightCurlyBracketKeyword_2_4__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_AttributesMapEntry_ColonKeyword_2_0_or_EqualsSignKeyword_2_1.equals(syntax))
				emit_AttributesMapEntry_ColonKeyword_2_0_or_EqualsSignKeyword_2_1(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_DispatchGroup___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q.equals(syntax))
				emit_DispatchGroup___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Dispatch___LeftParenthesisKeyword_2_0_RightParenthesisKeyword_2_3__q.equals(syntax))
				emit_Dispatch___LeftParenthesisKeyword_2_0_RightParenthesisKeyword_2_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Ambiguous syntax:
	 *     ('throughput' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) (ambiguity) (rule start)
	 *     (rule start) (ambiguity) dispatchGroups+=DispatchGroup
	 *     imports+=Import (ambiguity) (rule end)
	 *     imports+=Import (ambiguity) dispatchGroups+=DispatchGroup
	 */
	protected void emit_ActivityDispatching___ThroughputKeyword_2_0_LeftCurlyBracketKeyword_2_1_RightCurlyBracketKeyword_2_4__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ':' | '='
	 *
	 * This ambiguous syntax occurs at:
	 *     key=Attribute (ambiguity) value=IDString
	 *     key=Attribute (ambiguity) value=INTASString
	 */
	protected void emit_AttributesMapEntry_ColonKeyword_2_0_or_EqualsSignKeyword_2_1(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('(' ')')?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'activities' (ambiguity) 'repeat' ':' '[' repeats+=Range
	 *     (rule start) 'activities' (ambiguity) 'repeat' ':' repeats+=NumberRepeats
	 *     (rule start) 'activities' (ambiguity) 'repeat' iteratorName=IDString
	 *     (rule start) 'activities' (ambiguity) '{' 'offset' ':' offset=EBigDecimal
	 *     (rule start) 'activities' (ambiguity) '{' 'yield' ':' yield=INT
	 *     (rule start) 'activities' (ambiguity) '{' '}' (rule start)
	 *     (rule start) 'activities' (ambiguity) '{' dispatches+=Dispatch
	 *     (rule start) 'activities' (ambiguity) '{' resourceYield+=ResourceYieldMapEntry
	 *     name=IDString (ambiguity) 'repeat' ':' '[' repeats+=Range
	 *     name=IDString (ambiguity) 'repeat' ':' repeats+=NumberRepeats
	 *     name=IDString (ambiguity) 'repeat' iteratorName=IDString
	 *     name=IDString (ambiguity) '{' 'offset' ':' offset=EBigDecimal
	 *     name=IDString (ambiguity) '{' 'yield' ':' yield=INT
	 *     name=IDString (ambiguity) '{' '}' (rule end)
	 *     name=IDString (ambiguity) '{' dispatches+=Dispatch
	 *     name=IDString (ambiguity) '{' resourceYield+=ResourceYieldMapEntry
	 */
	protected void emit_DispatchGroup___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_2__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('(' ')')?
	 *
	 * This ambiguous syntax occurs at:
	 *     activity=[Activity|ID] (ambiguity) (rule end)
	 *     resourceItems+=[ResourceItem|ResourceItemQualifiedName] ']' (ambiguity) (rule end)
	 */
	protected void emit_Dispatch___LeftParenthesisKeyword_2_0_RightParenthesisKeyword_2_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
